//
// ͱѴκǾǥˡ
//
//	ּͱѴμư׻(6)	2001ǯ312
//

#include	"Mat.h"
#include	"Tensor.h"
#include	"CImage.h"

#include	"Corresp_cls.h"
#include	"homography.h"
#include	"lmeds.h"

// 4
static void
get_random_pairs(long *idumptr, Corresp cp[], int N, int indx[])
{
   int		p1, p2, p3, p4;

   p1 = (int)(N * ran1(idumptr));
   while ((p2 = (int)(N * ran1(idumptr))) == p1)
      ;
   while ((p3 = (int)(N * ran1(idumptr))) == p1 || p3 == p2)
      ;
   while ((p4 = (int)(N * ran1(idumptr))) == p1 || p4 == p2 || p4 == p3)
      ;
   indx[0] = p1;
   indx[1] = p2;
   indx[2] = p3;
   indx[3] = p4;
}

// ͱѴη׻(Ǿˡ)
// Ǿˡ

static const    VecC    e1(1.0, 0.0, 0.0);
static const    VecC    e2(0.0, 1.0, 0.0);
static const    VecC    e3(0.0, 0.0, 1.0);

// ľ˺ܤäħɤΥå
static int
linear_check(VecC& X1, VecC& X2, VecC& X3)
{
   double	d;

   d = (X1 , (X2 % X3));
   if (fabs(d) < DEGEN_EPS)
      return FAILED;

   return SUCCEEDED;
}

// Ǿˡˤ H η׻
static int
calc_H_lsm(VecC x0[], VecC x1[], int idx[], Mat &H)
{
   Tensor4      TM;
   Mat          Xa1, Xa2, Xa3;
   Mat          EgMat[9];
   VecC         EgVal(9);

   // ಽȽ
   if (   linear_check(x0[0], x0[1], x0[2])
       || linear_check(x0[1], x0[2], x0[3])
       || linear_check(x0[2], x0[3], x0[0])
       || linear_check(x1[0], x1[1], x1[2])
       || linear_check(x1[1], x1[2], x1[3])
       || linear_check(x1[2], x1[3], x1[0]))
      return FAILED;

   Xa1 = e1 % (x1[idx[0]] * (~x0[idx[0]]));
   Xa2 = e2 % (x1[idx[0]] * (~x0[idx[0]]));
   Xa3 = e3 % (x1[idx[0]] * (~x0[idx[0]]));

   TM = TensorProduct(Xa1, Xa1);
   TM += TensorProduct(Xa2, Xa2);
   TM += TensorProduct(Xa3, Xa3);

   for (int i = 1; i < 4; i++)
   {
      Xa1 = e1 % (x1[idx[i]] * (~x0[idx[i]]));
      Xa2 = e2 % (x1[idx[i]] * (~x0[idx[i]]));
      Xa3 = e3 % (x1[idx[i]] * (~x0[idx[i]]));

      TM += TensorProduct(Xa1, Xa1);
      TM += TensorProduct(Xa2, Xa2);
      TM += TensorProduct(Xa3, Xa3);
   }
   TM /= 4.0;

   Eigen3333(TM, EgVal, EgMat);

   H = EgMat[8];
   if (det(H) < 0.0) H = -H;

   return SUCCEEDED;
}

// J_{\lambda}η׻
static double
calc_J_lambda_homo(Mat& H, VecC& Xa, VecC& Xb)
{
   Mat	Pk(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
   Mat	T, W;
   double	J;

   T = (Xb % H) * Pk * (~H % Xb) + (H * Xa) % Pk % (H * Xa);
   W = trc_gen_inv(T, 2);
   J = (((Xb % H) * Xa), W * ((Xb % H) * Xa));

   return J;
}

// ׻줿ͱѴ󤫤бФλĺ׻
static double
calc_H_med(Mat &H, VecC Xa[], VecC Xb[], int N, double J0[])
{
   double	t;
   double	J[N];

   // ĺη׻
   for (int i = 0; i < N; i++)
      J0[i] = J[i] = calc_J_lambda_homo(H, Xa[i], Xb[i]);

   // ˥
   for (int i = 0; i < N - 1; i++)
      for (int j = i + 1; j < N; j++)
      {
	 if (J[i] > J[j])
	 {
	    t = J[j]; J[j] = J[i]; J[i] = t;
	 }
      }

   return J[N/2];
}
      
// Ǿ᥸ˡˤͱѴη׻
double
lmeds_homo(Corresp cp[], VecC Xa[], VecC Xb[], double J[],
	   int N, double fl, int MaxItr, Mat& Hm)
{
   double	S, Sm;
   Mat		H;
   int		indx[H_MIN_PTS];
   int		count, ct;

   // ֤Τν
   Hm.clear(0.0);
   Sm = INF;
   count = ct = 0;

   if (N > H_MIN_PTS * 4)
   {
      // бΥڥʬʸĿФǤ: 
      while (count < MaxItr)
      {
	 count++;

	 // 4
	 get_random_pairs(&idum, cp, N, indx);

	 // ͱѴη׻
	 if (calc_H_lsm(Xa, Xb, indx, H))
	 {
	    continue;
	 }

	 // бФλĺͤη׻
	 S = calc_H_med(H, Xa, Xb, N, J);

	 // 
	 if (S < Sm)
	 {
	    Sm = S;
	    Hm = H;
	    ct = 0;
	 }
	 else	// Ϣ³ COUNT_HOMO(9) ʾǽλ
	 {	// ȥ饤Ψ: 2䡤ȽΨ 1%ʲ
	    if (++ct >= COUNT_HOMO)
	       break;
	 }
      }
   }
   else
   {
      // бΥڥʤ: 
      for (indx[0] = 0; indx[0] < N - 3; indx[0]++)
      {
	 for (indx[1] = indx[0] + 1; indx[1] < N - 2; indx[1]++)
	 {
	    for (indx[2] = indx[1] + 1; indx[2] < N - 1; indx[2]++)
	    {
	       for (indx[3] = indx[2] + 1; indx[3] < N; indx[3]++)
	       {
		  // ͱѴη׻
		  if (calc_H_lsm(Xa, Xb, indx, H))
		  {
		     continue;
		  }

		  // бФλĺͤη׻
		  S = calc_H_med(H, Xa, Xb, N, J);

		  // 
		  if (S < Sm)
		  {
		     Sm = S;
		     Hm = H;
		  }
	       }
	    }
	 }
      }
   }

   return Sm;
}

// ͱѴκƤϤ
void
recalc_homo(Corresp cp[], VecC Xa0[], VecC Xb0[], double J[], int N,
	    double Sm, Mat& Hm,
	    Corresp **ncp, int *Nn, Mat& Hn)
{
   VecC		*Xa, *Xb;
   int		Nc, k;
   double	epsh;
   int		cnt;

   // Ʒ׻˻ȤбФο
   Nc = 0;
   for (int i = 0; i < N; i++)
   {
      J[i] = calc_J_lambda_homo(Hm, Xa0[i], Xb0[i]);
      if (J[i] < THD * Sm)
	 Nc++;
   }

   Xa = new VecC [Nc];
   Xb = new VecC [Nc];
   *ncp = new Corresp [Nc];
   *Nn = Nc;

   k = 0;
   for (int i = 0; i < N; i++)
   {
      if (J[i] < THD * Sm)
      {
	 (*ncp)[k].ua = cp[i].ua;
	 (*ncp)[k].va = cp[i].va;
	 (*ncp)[k].ub = cp[i].ub;
	 (*ncp)[k].vb = cp[i].vb;
	 Xa[k] = Xa0[i];
	 Xb[k] = Xb0[i];
	 k++;
      }
   }

   calc_homography(Xa, Xb, Nc, Hn, 2, 1e-10, 30, &epsh, &cnt);
}
