//
// ¿ʤκǾǥˡ
//
//	ּͱѴμư׻(3)
//		2001ǯ312
//

#include	"Mat.h"

#include	"Corresp_cls.h"
#include	"lmeds.h"

// J_{\lambda}η׻
static double
calc_J_lambda_tr(VecC& T, VecC& Xa, VecC& Xb)
{
   VecC		t;
   double	J;

   t = Xb - Xa - T;
   J = t.sqnorm() / 2.0;

   return J;
}

// ׻줿ͱѴ󤫤бФλĺ׻
static double
calc_T_med(VecC &T, VecC Xa[], VecC Xb[], int N, double J0[])
{
   double	t;
   double	J[N];

   // ĺη׻
   for (int i = 0; i < N; i++)
      J0[i] = J[i] = calc_J_lambda_tr(T, Xa[i], Xb[i]);

   // ˥
   for (int i = 0; i < N - 1; i++)
      for (int j = i + 1; j < N; j++)
      {
	 if (J[i] > J[j])
	 {
	    t = J[j]; J[j] = J[i]; J[i] = t;
	 }
      }

   return J[N/2];
}

// ¿ʤη׻
static void
calc_tr(VecC Xa[], VecC Xb[], int N, VecC& T)
{
   T.clear(0.0);
   for (int i = 0; i < N; i++)
      T += Xb[i] - Xa[i];

   T /= (double)N;
}

// Ǿ᥸ˡˤ¿ʤη׻
double
lmeds_tr(Corresp cp[], VecC Xa[], VecC Xb[], double J[],
	 int N, int MaxItr, VecC& Tm)
{
   double	S, Sm;
   VecC		T;
   int		idx;
   int		count, ct;

   // ֤Τν
   Tm.clear(0.0);
   Sm = INF;
   count = ct = 0;

   // 
   for (int i = 0; i < N; i++)
   {
      // 1
      idx = i;

      // ¿ʤη׻
      T = Xb[idx] - Xa[idx];

      // бФλĺͤη׻
      S = calc_T_med(T, Xa, Xb, N, J);

      // 
      if (S < Sm)
      {
	 Sm = S;
	 Tm = T;
      }
   }

   return Sm;
}

// ¿ʤκƤϤ
void
recalc_tr(Corresp cp[],
	  VecC Xa0[], VecC Xb0[], double J[],
	  int N, double Sm, VecC& Tm,
	  Corresp **ncp, int *Nn, VecC& T)
{
   VecC	*Xa, *Xb;
   int	Nc, k;

   // Ʒ׻˻ȤбФο
   Nc = 0;
   for (int i = 0; i < N; i++)
   {
      VecC	t;

      t = Xa0[i] + Tm - Xb0[i];
      J[i] = t.sqnorm() / 2.0;
      if (J[i] < THD * Sm)
	 Nc++;
   }

   Xa = new VecC [Nc];
   Xb = new VecC [Nc];
   *ncp = new Corresp [Nc];
   *Nn = Nc;

   k = 0;
   for (int i = 0; i < N; i++)
   {
      if (J[i] < THD * Sm)
      {
	 (*ncp)[k].ua = cp[i].ua;
	 (*ncp)[k].va = cp[i].va;
	 (*ncp)[k].ub = cp[i].ub;
	 (*ncp)[k].vb = cp[i].vb;
	 Xa[k] = Xa0[i];
	 Xb[k] = Xb0[i];
	 k++;
      }
   }

   calc_tr(Xa, Xb, Nc, T);
}
