//
// ƥץ졼ȥޥå󥰤ˤбõ
// :ּͱѴμư׻(6)
//	2001ǯ312
//	4. бκб
//
//	IndexPair, Point κ

#include	"CImage.h"

#include	"Corresp_cls.h"
#include	"grouping.h"
#include	"init_match.h"
#include	"rematch.h"

// 
static double
sqr(double x)
{
   return x * x;
}

// ɸѴ
static VecC
convert_vec(Point cp, int width, int height, double fl)
{
   VecC	X;
   int	w2 = width / 2;
   int	h2 = height / 2;

   X[0] = (double)(h2 - cp.v) / fl;
   X[1] = (double)(cp.u - w2) / fl;
   X[2] = 1.0;

   return X;
}


// 33x33 Υƥץ졼Ⱥ
static void
get_template(Image& Im, Point& p, IntTemplate& Tp)
{
   int		d;
   
   for (int j = Tp.ymin(); j <= Tp.ymax(); j++)
      for (int i = Tp.xmin(); i <= Tp.xmax(); i++)
      {
	 d = Im.get_im_pixel2(p.u+i, p.v+j);
	 Tp.put_im_pixel(i, j, d);
      }
}

// ƥץ졼(1)2ħޤΰȤ
// ͱƥƥץ졼ȥޥå
static double
homo_tp_matching(IntTemplate& Ta, Image& Imb, Point& pb,
		 VecC& Xa, VecC& Xb, Mat& Hm, double fl)
{
   Mat		T;
   VecC		Vi(1.0, 0.0, 0.0), Vj(0.0, 1.0, 0.0), Vk(0.0, 0.0, 1.0);
   VecC		X0, X1;
   VecC		Tv;
   int		sx, sy, ex, ey, xb, yb;
   double	b, d;
   double	xp, yp;
   double	s;

   sx = Ta.xmin();
   ex = Ta.xmax();
   sy = Ta.ymin();
   ey = Ta.ymax();

   xb = Imb.height() / 2 - pb.v;
   yb = pb.u - Imb.width() / 2;

   Tv = Vk + Xb - Znorm(Hm * Xa);
   
   for (int i = 0; i < 3; i++)
   {
      T[i][0] = Vi[i];
      T[i][1] = Vj[i];
      T[i][2] = Tv[i];
   }

   s = 0.0;
   for (int y = sy; y <= ey; y++)
      for (int x = sx; x <= ex; x++)
      {
	 X0[0] = Xa[0] + x / fl;
	 X0[1] = Xa[1] + y / fl;
	 X0[2] = 1.0;
	 X1 = Znorm(T * Hm * X0);
	 xp = X1[0] * fl;
	 yp = X1[1] * fl;

	 b = Imb.get_cpixel(xp, yp);
	 if (b < 0)	// ϰϳ
	    return MISMATCH;
	 d = Ta.get_pixel(x, y);
	 s += sqr(b - d);
      }
   return s;
}

// J_{\lambda}η׻
// ƱΤ lmeds-homo ˤ⤢뤳Ȥ
static double
calc_J_lambda_homo(Mat& H, VecC& Xa, VecC& Xb)
{
   Mat	Pk(1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0);
   Mat	T, W;
   double	J;

   T = (Xb % H) * Pk * (~H % Xb) + (H * Xa) % Pk % (H * Xa);
   W = trc_gen_inv(T, 2);
   J = (((Xb % H) * Xa), W * ((Xb % H) * Xa));

   return J;
}

// Jab κƷ׻ȥå
static void
recalc_table(Mat& Jab, Mat& lambda, Image& Ima, Image& Imb,
	     Point pa[], Point pb[], int Na, int Nb,
	     int width, int height, double fl, int tsize,
	     Mat& Hm, double dthd)
{
   IntTemplate	Ta(tsize,tsize); //  9x9  33x33 Υƥץ졼
   VecC		Xa, Xb;
   double	Jl;
	     
   // 7*SmʲͭȤ롥
   for (int a = 0; a < Na; a++)
   {
      Xa = convert_vec(pa[a], width, height, fl);
      get_template(Ima, pa[a], Ta);
      for (int b = 0; b < Nb; b++)
      {
	 Xb = convert_vec(pb[b], width, height, fl);
	 Jl = calc_J_lambda_homo(Hm, Xa, Xb);
	 if (Jl < (dthd / (2.0 * fl * fl)))
	 {
	    Jab[a][b] = homo_tp_matching(Ta, Imb, pb[b], Xa, Xb, Hm, fl);
	    lambda[a][b] = 1.0;
	 }
	 else
	 {
	    Jab[a][b] = MISMATCH;
	    lambda[a][b] = MISMATCH;
	 }
      }
   }
}

// ͱѴκб
int
rematch_homo(Image& Ima, Image& Imb,
	     Mat& Jab, Point pa[], Point pb[],
	     int width, int height, double fl, 
	     Mat& Hm, double dthd, int tsize, 
	     Corresp **cp0, int* N0)
// Jab0[][] ϺǽΥޥå󥰤κݤΤ
{
   int		Na, Nb, NNa, NNb, L;
   IndexPair	*idx, *idx0;
   double	*x;
   Corresp	*cp;
   int		*grp;
   int		N, Nm;
//   int		thd;	// 롼ԥ󥰤ʤɬפʤ

   // 줾βħθĿμ
   Na = Jab.row();
   Nb = Jab.col();
   Mat	lambda(Jab.row(),Jab.col());

   // Jab κƷ׻ȥå
   recalc_table(Jab, lambda, Ima, Imb, pa, pb, Na, Nb, width, height, fl,
		tsize, Hm, dthd);

   N = Na * Nb;
   idx = new IndexPair [N];	// ǥ
   grp = new int [N];		// 롼
   x = new double [N];		// ѥ
   Mat	Jab0(Jab);		// Jab Υԡ

   // ǥ
   N = make_index2(Jab0, lambda, Na, Nb, idx, x, &NNa, &NNb);

   // 롼ԥ
   L = (NNa < NNb)? NNa: NNb;
   idx0 = new IndexPair [L];	// ǥ

   // 
   sort_index_pair(Jab0, idx, N);

   // бγ
   Nm = fix_corresp(Jab0, Na, Nb, N, idx0, idx);

   // бФι¤ΤؤѴ
   cp = (*cp0) = new Corresp [Nm];
   corresp_pairs(pa, pb, idx0, Nm, cp);

   delete [] idx0;
   delete [] idx;
   delete [] x;
   
   return (*N0 = Nm);
}
