#ifndef _SIMILAR_H_
#define _SIMILAR_H_

#include "fitting_consts.h"

// ˥塼ȥˡνͤη׻
int     init_similar(VecC* x0, VecC* x1, int N, Mat& S);

// Ѵ׻ (˥塼ȥˡ)
double	calc_similar(VecC* x0, VecC* x1, int N,
		     double eps_s, double eps_th, double eps_T, int max_itr,
		     double *scale, Mat& Rot, VecC& tr,
		     double *eh, int *count);

// Ѵ׻ (Levenburg-Marquardtˡ)
double  calc_similarlm(VecC* x0, VecC* x1, int N,
		       double eps_s, double eps_th, double eps_T, int max_itr,
		       double *scale, Mat& Rot, VecC& tr,
		       double *eh, int *count);

#endif  // _SIMILAR_H_
